
/**
 * 网易云音乐整合
 * 制作：柠儿（QQ：3463448740）
 */
const AUTHER = '青柠';
const QQ = 3463448740;
const types = {
	type: 'NETEASE_MUSIC_RESOURCE_WIDGET',
	icon: 'https://www.lihouse.xyz/coco_widget/music_resource/logo.svg',
	title: '网易云整合搜索',
	version: '1.0.0',
	auther: AUTHER,
	docs: {
		url: 'https://doc.lihouse.xyz/music_resource.html',
	},
	platforms: ['web', 'android', 'ios',],
	isInvisibleWidget: true,
	isGlobalWidget: true,
	hasAnyWidget: false,
	properties: [
	],
	methods: [
		{
			key: 'search', label: '获取音乐资源通过',
			params: [
				{ key: 'id', label: '歌曲id', valueType: 'string', defaultValue: '30148635', },
			], blockOptions: { color: '#68cdff', },
		},
		{
			key: 'info', label: '搜索歌曲信息',
			params: [
				{ key: 'key', label: '搜索内容(歌名或歌手等)', valueType: 'string', defaultValue: '不眠之夜'},
				{ key: 'page', label: '第几', valueType: 'number', defaultValue: '1', labelAfter :'面'},
				{ key: 'limit', label: '每面返回', valueType: 'number', defaultValue: '5', labelAfter :'个'}
			], blockOptions: { color: '#68cdff', },
		},
	],
	events: [
		{
			key: 'onSuc', label: '成功获取歌曲资源', params: [
				{ key: 'url', label: '歌曲热链接', valueType: 'string', },
				{ key: 'name', label: '歌曲名称', valueType: 'string', },
                { key: 'album', label: '专辑名称', valueType: 'string', },
                { key: 'artist', label: '歌手', valueType: 'string', },
                { key: 'pic', label: '歌曲图片链接', valueType: 'string', },
				{ key: 'lyric', label: '歌曲标准歌词字符串', valueType: 'string', },
			],
		},
		{
			key: 'onResult', label: '成功获取搜索信息', params: [
				{ key: 'id', label: '歌曲id', valueType: 'number', },
				{ key: 'name', label: '歌曲名称', valueType: 'string', },
				{ key: 'artist', label: '歌手', valueType: 'string', },
                { key: 'album', label: '专辑名称', valueType: 'string', },
                { key: 'pic', label: '歌曲图片链接', valueType: 'string', },
			],
		},
		{
			key: 'onError', label: '获取出错', params: [{ key: 'reason', label: '错误原因', valueType: 'string', }],
		},
	],
};
const axios = require('axios');
class Widget extends InvisibleWidget {
	constructor(props) {
		super(props);
		this.url = props.url;
	};
	search(key) {
        axios.get('https://www.lihouse.xyz/coco_widget/music_resource/id/'+key).then(response => {
            let raw = response.data
            if(raw.status){
                this.emit('onSuc', raw.song_data.url , raw.song_data.name , raw.song_data.album , raw.song_data.artist , raw.song_data.pic, raw.song_data.lyric)
            }else{
                this.emit('onEror', raw.msg)
            }
        }, error => {
            this.widgetError(error)
        })
	}

	info(key,page,limit) {
        axios.get('https://www.lihouse.xyz/coco_widget/music_resource/info?key='+key+'&page='+page+'&limit='+limit).then(response => {
            let raw = response.data
            if(raw.status){
                this.traverseJson(raw.song_data);
            }else{
                this.emit('onEror', raw.msg);
            }
        }, error => {
            this.widgetError(error)
        })
	};

	traverseJson(jsonData) {
		console.log(jsonData)
		for (let item of jsonData) {
			this.emit('onResult',item.id , item.name , item.artist.join(", ") , item.album , item.pic );
		}
	}
};
exports.types = types;
exports.widget = Widget;
